<template>
    <div class="page">
        <LayoutTable :data="tableData" :config="tableConfig">
                    </LayoutTable>


        <drawer-show ref="drawerform" @ok="getData" />
    </div>
</template>

<script>
    /** 表单弹出框模式需引入 */
    import drawerShow from "./drawershow";
    import table from "@/assets/mixins/table";
    export default {
        name: "LicenseList",
        components: {
            drawerShow
},
        mixins: [table],
        created() {
        },
        methods: {
            /** 重写新增方法 */
            toAdd(row) {
                this.$refs.drawerform.add(row);
            },
            /** 重写编辑方法 */
            toEdit(row) {
                this.$refs.drawerform.edit(row);
            },
            /** 重写查看方法 */
            toView(row) {
                this.$refs.drawerform.view(row);
            },

          handleGenLicense(row) {
            console.log("gen", row);
            const tableIds = row.id || this.ids;
            if (tableIds == "") {
              this.$message.error("请选择要生成证书的数据");
              return;
            }
            this.loading = true;

              this.$download(
                  "/license/download",
                  {
                    id: row.id
                  },
                  { type: "zip" }
              )
                  .then((res) => {
                    this.loading = false;
                  })
                  .catch((error) => {
                    console.log("error", error);
                    this.$message.error(error.message);
                  });

          },

        },
        data() {
            return {
                config: {
                    search: [
                    ],
                    columns: [
                        {type: "selection", width: 60},
                        {type: "index",label: "序号",width: 50},
                      {label: "项目名称", prop: "name"},

                        {label: "服务器mac地址", prop: "mac"},
                        {label: "服务器IP地址", prop: "ip"},

                        {label: "许可证颁发日期", prop: "startTime", formatter: this.formatterDateOnly},

                        {label: "许可证过期日期", prop: "endTime", formatter: this.formatterDateOnly},

                        {label: "许可证状态", prop: "licenseStatus"},


                        {label: "创建时间", prop: "createTime", formatter: this.formatterDate},

                        {
                            label: "操作",
                            width: 240,
                            formatter: row => {
                                return (

                                    <div>
                                      <table-buttons
                                          noAdd
                                          row={row}
                                          onEdit={this.toEdit}
                                          onView={this.toView}
                                          onDel={this.toDel}
                                      />
                                      <span> </span>

                                      <el-button
                                          type="text"
                                          size="small"
                                          icon="el-icon-download"
                                          onClick={() => {
                                            this.handleGenLicense(row);
                                          }}
                                      >
                                        生成证书
                                      </el-button>
                 </div>

                            );
                            }
                        }
                    ]
                }
            };
        }
    };
</script>
